#!/usr/bin/env python
# import sys
# import argparse
# import pickle
# import shutil
# import os
# import base64
# from cryptography.fernet import Fernet
# from cryptography.hazmat.backends import default_backend
# from cryptography.hazmat.primitives import hashes
# from cryptography.hazmat.primitives.kdf.pbkdf2 import PBKDF2HMAC
# from Tkinter import Tk
# from getpass import getpass
#
# DEFAULT_FILE = 'crypt.bin'
# VERIFY_KEY = '2390  sdflk=asdlasdjkl113'
#
#
# def computeFernetKey(url, password):
#     kdf = PBKDF2HMAC(
#         algorithm=hashes.SHA256(),
#         length=32,
#         salt=url,
#         iterations=100000,
#         backend=default_backend())
#     key = base64.urlsafe_b64encode(kdf.derive(password))
#     f = Fernet(key)
#     return f
#
#
# def encrypt(plaintext, salt, password):
#     try:
#         f = computeFernetKey(salt, password)
#         ciphertext = f.encrypt(plaintext)
#         return ciphertext
#     except:
#         return None
#
#
# def decrypt(ciphertext, salt, password):
#     try:
#         f = computeFernetKey(salt, password)
#         plaintext = f.decrypt(ciphertext, None)
#         return plaintext
#     except:
#         return None
#
#
# def readCrypt(fname):
#     handle = open(fname, 'rb')
#     crypt = pickle.load(handle)
#     handle.close()
#     return crypt
#
#
# def writeCrypt(crypt, fname):
#     handle = open(fname, 'wb')
#     crypt = pickle.dump(crypt, handle)
#     handle.close()
#
#
# def copyCrypt(fromFile, toFile):
#     shutil.copyfile(fromFile, toFile)
#
#
# def delCrypt(file):
#     os.remove(file)
#
#
# def init(args):
#     if os.path.exists(args.file):
#         print 'File already exists.'
#     else:
#         crypt = {}
#         key = VERIFY_KEY
#         salt = VERIFY_KEY
#         cipher = encrypt(key, salt, args.master)
#         crypt[key] = [salt, cipher]
#         fileHandle = open(args.file, 'wb')
#         pickle.dump(crypt, fileHandle)
#         fileHandle.close()
#         print 'Ok'
#
#
# def verify(password, crypt):
#     try:
#         verifierEntry = crypt[VERIFY_KEY]
#         verifyCipher = verifierEntry[1]
#         plaintext = decrypt(verifyCipher, VERIFY_KEY, password)
#         return plaintext == VERIFY_KEY
#     except:
#         return False
#
#
# def add(args):
#     if args.url == VERIFY_KEY:
#         print 'Bad key.'
#         return
#
#     copyCrypt(args.file, args.file + ".bak")
#     crypt = readCrypt(args.file)
#     args.master = getMaster()
#
#     if verify(args.master, crypt):
#         try:
#             cipher = encrypt(args.pword, args.url, args.master)
#             crypt[args.url] = [args.name, cipher]
#             writeCrypt(crypt, args.file)
#             delCrypt(args.file + ".bak")
#             print 'Ok'
#         except:
#             print 'IO Error'
#     else:
#         print 'No'
#
#
# def get(args):
#     crypt = readCrypt(args.file)
#     key = args.url
#     args.master = getMaster()
#
#     if key in crypt:
#         entry = crypt[key]
#         plaintext = decrypt(entry[1], key, args.master)
#         if plaintext == None:
#             print 'No'
#             return
#         # r places the decrypted password on to the clipboard
#         r = Tk()
#         r.withdraw()
#         r.clipboard_clear()
#         r.clipboard_append(plaintext)
#         r.destroy()
#         print key + ' --> ' + entry[0]
#     else:
#         print 'No'
#
#
# def remove(args):
#     copyCrypt(args.file, args.file + ".bak")
#     crypt = readCrypt(args.file)
#     args.master = getMaster()
#     if verify(args.master, crypt):
#         try:
#             if args.url != VERIFY_KEY:
#                 crypt.pop(args.url, None)
#                 writeCrypt(crypt, args.file)
#                 delCrypt(args.file + ".bak")
#                 print 'Ok'
#             else:
#                 print 'No'
#         except:
#             print 'IO Error'
#     else:
#         print 'No'
#
#
# def show(args):
#     crypt = readCrypt(args.file)
#     for key in crypt:
#         if key != VERIFY_KEY:
#             entry = crypt[key]
#             # print "{ " + key + ', ' + entry[0] + ' }'
#             print "{ " + key + ' }'
#
#
# def auto(name):
#     return name
#
#
# def create(args):
#     pword = auto(args.name)
#     args.pword = pword
#     add(args)
#
#
# def getMaster():
#     master = getpass("?")
#     return master
#
#
# def change(args):
#     copyCrypt(args.file, args.file + ".bak")
#     crypt = readCrypt(args.file)
#     args.master = getMaster()
#     if verify(args.master, crypt):
#         try:
#             if args.url != VERIFY_KEY:
#                 entry = crypt[args.url]
#                 if entry != None:
#                     if (args.name == None):
#                         args.name = entry[0]
#                     cipher = encrypt(args.pword, args.url, args.master)
#                     entry = [args.name, cipher]
#                     writeCrypt(crypt, args.file)
#                     delCrypt(args.file + ".bak")
#                     print 'Ok'
#                 else:
#                     print 'No'
#             else:
#                 print 'No'
#         except:
#             print 'IO Error'
#     else:
#         print 'No'
#
#
# def buildParsers():
#     # top level parsers
#     topParser = argparse.ArgumentParser(description='Guards your crypt.')
#     topParser.add_argument('-file', default=DEFAULT_FILE,
#                            help='filename, default is ' + DEFAULT_FILE)
#     subParsers = topParser.add_subparsers(help='command help')
#
#     # init parser
#     initParser = subParsers.add_parser('init', help='create new crypt')
#     initParser.add_argument('master', help='master password')
#     initParser.set_defaults(func=init)
#
#     # add - explicit create
#     addParser = subParsers.add_parser(
#         'add', help='explicitly create a new login')
#     addParser.add_argument('url', help='login url')
#     addParser.add_argument('name', help='login name')
#     addParser.add_argument('pword', help='login pword')
#     addParser.set_defaults(func=add)
#
#     # create parser
#     createParser = subParsers.add_parser(
#         'auto', help='autocreate password and new login')
#     createParser.add_argument('url')
#     createParser.add_argument('name')
#     createParser.set_defaults(func=create)
#
#     # show parser
#     showParser = subParsers.add_parser('show', help='show logins')
#     showParser.set_defaults(func=show)
#
#     # get parser
#     getParser = subParsers.add_parser('get', help='retrieve login')
#     getParser.add_argument('url')
#     getParser.set_defaults(func=get)
#
#     # change parser
#     changeParser = subParsers.add_parser('change', help='change password')
#     changeParser.add_argument('url', help='login url')
#     changeParser.add_argument('-name', help='login name')
#     changeParser.add_argument('pword', help='login pword')
#     changeParser.set_defaults(func=change)
#
#     # remove parser
#     removeParser = subParsers.add_parser('del', help='delete login')
#     removeParser.add_argument('url')
#     removeParser.set_defaults(func=remove)
#
#     return topParser
#
#
# def lichmain(args=None):
#     parser = buildParsers()
#     args = parser.parse_args()
#     args.func(args)
#
#

# def main(args=None):
#     lichmain()

from lich import lichmain
if __name__ == "__main__":
    lichmain()
