#!/usr/bin/env python
import argparse
import os
from Tkinter import *
import lich

class Flesh:

    def __init__(self, master, fileName):

        frame = Frame(master)
        frame.pack()
        master.title('Flesh')

        self.file = fileName

        self.show = Button(frame, text="show", command=self.show)
        self.show.pack(side=LEFT)

        self.add = Button(frame, text="add", command=self.add)
        self.add.pack(side=LEFT)

        self.get = Button(frame, text="get", command=self.get)
        self.get.pack(side=LEFT)

        self.delete = Button(frame, text="del", command=self.delete)
        self.delete.pack(side=LEFT)

        self.input = Entry(frame, width=40)
        self.input.pack(side=LEFT)

        self.submit = Button(frame,text='submit', command=self.submit)
        self.submit.pack(side=LEFT)

    def submit(self):
        #tokenize
        #issue command based on first token
        command = self.input.get()

        tokens = command.split()
        numTokens = len(tokens)
        #early exit
        if numTokens == 0:
            self.input.delete(0, END)
            return

        if tokens[0] == 'add':
            if numTokens == 5:
                lich.addOneEntry(self.file, tokens[1], tokens[2], tokens[3], tokens[4])
        elif tokens[0] == 'del':
            if numTokens == 3:
                lich.removeOneEntry(self.file, tokens[1], tokens[2])
        elif tokens[0] == 'get':
            if numTokens == 3:
                lich.getOneEntry(self.file, tokens[1], tokens[2])

        self.input.delete(0, END)

    def add(self):
        self.input.delete(0, END)
        self.input.insert(0, 'add [url] [name] [password] [master]')

    def get(self):
        self.input.delete(0, END)
        self.input.insert(0, 'get [url] [master]')

    def delete(self):
        self.input.delete(0, END)
        self.input.insert(0, 'del [url] [master]')

    def show(self):
        print 'Running show on file ' + self.file
        lich.doOneShow(self.file)

#idea: Parse the arguments to the commands and present these to user..
#failing that: figure out how to submit args to functions without wrapping a wrapper

def buildParsers():
    # top level parsers
    topParser = argparse.ArgumentParser(description='Puts skin on them bones.')
    topParser.add_argument('-file', default=lich.DEFAULT_FILE,
                           help='filename, default is ' + lich.DEFAULT_FILE)
    return topParser

def fleshmain(args=None):
    parser = buildParsers()
    args = parser.parse_args()
    args.file = os.path.abspath(args.file)
    print 'Using crypt at '+args.file
    root = Tk()
    app = Flesh(root, args.file)
    root.mainloop()
    #root.destroy()

if __name__ == "__main__":
    fleshmain()
